#####################################################
#  LEO SuperCool BBS / LeoBBS X / 雷傲極酷超級論壇  #
#####################################################
# 基於山鷹(糊)、花無缺製作的 LB5000 XP 2.30 免費版  #
#   新版程式製作 & 版權所有: 雷傲科技 (C)(R)2004    #
#####################################################
#      主頁地址： http://www.LeoBBS.com/            #
#      論壇地址： http://bbs.LeoBBS.com/            #
#####################################################

    $ingetpassq        = &cleaninput($query -> param("getpassq"));
    $ingetpassa        = &cleaninput($query -> param("getpassa"));

    $inmembernamefile = $inmembername;
    $inmembernamefile =~ s/ /\_/g;
    $inmembernamefile =~ tr/A-Z/a-z/;

    opendir (DIRS, "${lbdir}$msgdir");
    my @files = readdir(DIRS);
    closedir (DIRS);
    @files = grep(/\.cgi$/i, @files);
    foreach (@files) {unlink ("${lbdir}$msgdir/$_") if ((-M "${lbdir}$msgdir/$_") > 1);}

    if (-e "${lbdir}$msgdir/$inmembernamefile.cgi") {
    	&error("密碼獲得失敗&請不要重複獲取密碼，論壇規定會員每１５分鐘$div_then能取得密碼$div_one次！") if((-M "${lbdir}$msgdir/$inmembernamefile.cgi") *86400 < 900);
    }

    if ($password ne "") {
    	if (-e "${lbdir}$msgdir/$inmembernamefile.cgi") {
    	    open(FILE, "${lbdir}$msgdir/$inmembernamefile.cgi");
    	    $x = <FILE>;
    	    close(FILE);
    	    chomp $x;
	} else {
	    $x = &myrand(1000000000);
	    $x = crypt($x, aun);
	    $x =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/eg;
	    $x =~ s/[^\w\d]//g;
	    $x = substr($x, 2, 6);
	}
    	open(FILE, ">${lbdir}$msgdir/$inmembernamefile.cgi");
    	print FILE "$x";
    	close(FILE);
    	$password = "$x$password";
        eval {$password = md5_hex($password);};
        if ($@) {eval('use Digest::MD5 qw(md5_hex);$password = md5_hex($password);');}
    }
    else { &error("密碼獲得失敗&你的密碼資料已經遺失，請聯絡管理員修復！"); }

    if (($membercode eq "ad")||($membercode eq "smo")) { require "doblocked.pl"; }
    elsif (($ingetpassq ne "")&&($ingetpassa ne "")) {
	my ($getpassq, $getpassa) =split(/\|/,$userquestion); 
	if(($ingetpassq eq $getpassq)&&($ingetpassa eq $getpassa)&&($membercode ne "mo")&&($membercode ne "amo")&&($membercode ne "cmo")){
	    $inmembername1 = uri_escape($inmembername);
	    $output .= qq~ 
<tr><td bgcolor=$titlecolor $catbackpic valign=middle align=center><font color=$fontcolormisc><b>你好，$inmembername</b></font></td></tr> 
<tr><td bgcolor=$miscbackone align=center><font color=$fontcolormisc>應您的要求，現將您的論壇密碼獲取方式給您！</td></tr> 
<tr><td bgcolor=$miscbackone align=center><font color=$fontcolormisc> 
您的會員名稱：$inmembername<br><br><B><a href="$boardurl/getmypass.cgi?username=$inmembername1&password=$password">請按此獲得您的論壇密碼</a></B><br><br>
注意：此連結在$div_one天後失效，請盡快瀏覽並進行密碼修改。<BR><BR>
</td></tr></table></td></tr></table><SCRIPT>valignend()</SCRIPT><BR><BR>
~;
	} else { 
	    $output .= qq~
<tr><td bgcolor=$titlecolor $catbackpic valign=middle align=center><font color=$fontcolormisc><b>非常抱歉，$inmembername</b></font></td></tr>
<tr><td bgcolor=$miscbackone align=center><font color=$fontcolormisc>
你所輸入的論壇密碼提示問題和答案不正確，或是你沒有在個人資料中填寫，所以無法取回！ (注意：如果你是版主，出於安全考慮，請用郵件取回論壇密碼！)
</td></tr></table></td></tr></table>
<SCRIPT>valignend()</SCRIPT>
~;
	    unlink ("${lbdir}$msgdir/$inmembernamefile.cgi");
	    }
	}
	elsif ($emailfunctions eq "off") {
	    $output .= qq~
<tr><td bgcolor=$titlecolor $catbackpic valign=middle align=center><font color=$fontcolormisc><b>非常抱歉，$inmembername</b></font></td></tr>
<tr><td bgcolor=$miscbackone align=center><font color=$fontcolormisc>
由於這個論壇的傳送郵件功\能已經關閉，請通過另$div_out的$div_way徑來聯絡壇主而拿取您的論壇密碼！
</td></tr></table></td></tr></table>
<SCRIPT>valignend()</SCRIPT>
~;
	}
	elsif ($userregistered ne "no") {
	    $inmembername1 = uri_escape($inmembername);
	    eval("use MAILPROG qw(sendmail);");
	    $message .= "\n";
	    $message .= "$boardname <br>\n";
	    $message .= "$boardurl/leobbs.cgi \n<br><br>\n";
	    $message .= "------------------------------------------------<br>\n";
	    $message .= "應您的要求，現將您的論壇密碼獲取方式寄給您！\n <br><br>\n";
	    $message .= "您的會員名稱：$inmembername <br>\n";
	    $message .= "您的論壇密碼按此獲得： $boardurl/getmypass.cgi?username=$inmembername1&password=$password \n <br><br>\n";
	    $message .= "注意：此連結在$div_one天後失效，請盡快瀏覽並進行密碼修改。<br><br>\n";
	    $message .= "------------------------------------------------<br>\n";
	    $to = $emailaddress;
	    $from = $adminemail_out;
	    $subject = "忘記論壇密碼[$boardname]";
	    if (&sendmail($from, $from, $to, $subject, $message)) {
                $output =~ s/會員資料/論壇密碼已經寄出/g;
                $output .= qq~
<tr><td bgcolor=$titlecolor $catbackpic valign=middle align=center><font color=$fontcolormisc><b>你好，$inmembername</b></font></td></tr>
<tr><td bgcolor=$miscbackone align=center><font color=$fontcolormisc>您的論壇密碼獲取方式已經成功\的通過指定的郵件地址傳送給您了。</td></tr></table></td></tr></table>
~;
	    } else {
		&error("密碼郵遞失敗&似乎伺服器傳送郵件過程中出了$div_one些問題，請稍後重試。");
	    }
	} else {
	    &error("請求論壇密碼&錯$div_wrong，您不是註冊會員！");
	}
1;
